Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.google.common.collect
Class ForwardingSortedMap<K,V>

    java.lang.Object
      com.google.common.collect.ForwardingObject
          com.google.common.collect.ForwardingMap<K,V>
              com.google.common.collect.ForwardingSortedMap<K,V>

All Implemented Interfaces:
  Map<K,V>, SortedMap<K,V>

    @GwtCompatible
    public abstract class ForwardingSortedMap<K,V>

extends ForwardingMap<K,V>
implements SortedMap<K,V>

A sorted map which forwards all its method calls to another sorted map. Subclasses should override one or more methods to modify the behavior of the backing sorted map as desired per the decorator pattern.

Warning: The methods of `ForwardingSortedMap` forward indiscriminately to the methods of the delegate. For example, overriding `ForwardingMap.put(K, V)` alone will not change the behavior of `ForwardingMap.putAll(java.util.Map)`, which can lead to unexpected behavior. In this case, you should override `putAll` as well, either providing your own implementation, or delegating to the provided `standardPutAll` method.

Each of the `standard` methods, where appropriate, use the comparator of the map to test equality for both keys and values, unlike `ForwardingMap`.

The `standard` methods and the collection views they return are not guaranteed to be thread-safe, even when all of the methods that they depend on are thread-safe.

Since:
  2.0 (imported from Google Collections Library)
Author:
  Mike Bostock, Louis Wasserman

Nested Class Summary

Nested classes/interfaces inherited from class com.google.common.collect.ForwardingMap
`ForwardingMap.StandardEntrySet, ForwardingMap.StandardKeySet, ForwardingMap.StandardValues`

Nested classes/interfaces inherited from interface java.util.Map
`Map.Entry<K,V>`

Constructor Summary
`protected` | `ForwardingSortedMap()` Constructor for use by subclasses.

Method Summary
`Comparator<? super K>` | `comparator()`
`protected abstract SortedMap<K,V>` | `delegate()` Returns the backing delegate instance that methods are forwarded to.
`K` | `firstKey()`
`SortedMap<K,V>` | `headMap(K toKey)`
`K` | `lastKey()`
`protected boolean` | `standardContainsKey(Object key)` A sensible definition of `ForwardingMap.containsKey(java.lang.Object)` in terms of the `firstKey()` method of `tailMap(K)`.
`protected V` | `standardRemove(Object key)` A sensible definition of `ForwardingMap.remove(java.lang.Object)` in terms of the `iterator()` of the `entrySet()` of `tailMap(K)`.
`protected SortedMap<K,V>` | `standardSubMap(K fromKey, K toKey)` A sensible default implementation of `subMap(Object, Object)` in terms of `headMap(Object)` and `tailMap(Object)`.
`SortedMap<K,V>` | `subMap(K fromKey, K toKey)`
`SortedMap<K,V>` | `tailMap(K fromKey)`

Methods inherited from class com.google.common.collect.ForwardingMap
`clear, containsKey, containsValue, entrySet, equals, get, hashCode, isEmpty, keySet, put, putAll, remove, size, standardClear, standardContainsValue, standardEntrySet, standardEquals, standardHashCode, standardIsEmpty, standardKeySet, standardPutAll, standardToString, standardValues, values`

Methods inherited from class com.google.common.collect.ForwardingObject
`toString`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.util.SortedMap
`entrySet, keySet, values`

Methods inherited from interface java.util.Map
`clear, containsKey, containsValue, equals, get, hashCode, isEmpty, put, putAll, remove, size`

Constructor Detail

### ForwardingSortedMap

    protected ForwardingSortedMap()

  Constructor for use by subclasses.

Method Detail

### delegate

    protected abstract SortedMap<K,V> delegate()

  Description copied from class: `ForwardingObject`
  Returns the backing delegate instance that methods are forwarded to. Abstract subclasses generally override this method with an abstract method that has a more specific return type, such as `ForwardingSet.delegate()`. Concrete subclasses override this method to supply the instance being decorated.

  Specified by:
    `delegate` in class `ForwardingMap<K,V>`

### comparator

    public Comparator<? super K> comparator()

  Specified by:
    `comparator` in interface `SortedMap<K,V>`

### firstKey

    public K firstKey()

  Specified by:
    `firstKey` in interface `SortedMap<K,V>`

### headMap

    public SortedMap<K,V> headMap(K toKey)

  Specified by:
    `headMap` in interface `SortedMap<K,V>`

### lastKey

    public K lastKey()

  Specified by:
    `lastKey` in interface `SortedMap<K,V>`

### subMap

    public SortedMap<K,V> subMap(K fromKey,
                                 K toKey)

  Specified by:
    `subMap` in interface `SortedMap<K,V>`

### tailMap

    public SortedMap<K,V> tailMap(K fromKey)

  Specified by:
    `tailMap` in interface `SortedMap<K,V>`

### standardContainsKey

    @Beta
    protected boolean standardContainsKey(@Nullable
                                               Object key)

  A sensible definition of `ForwardingMap.containsKey(java.lang.Object)` in terms of the `firstKey()` method of `tailMap(K)`. If you override `tailMap(K)`, you may wish to override `ForwardingMap.containsKey(java.lang.Object)` to forward to this implementation.

  Overrides:
    `standardContainsKey` in class `ForwardingMap<K,V>`
  Since:
    7.0

### standardRemove

    @Beta
    protected V standardRemove(@Nullable
                                    Object key)

  A sensible definition of `ForwardingMap.remove(java.lang.Object)` in terms of the `iterator()` of the `entrySet()` of `tailMap(K)`. If you override `tailMap(K)`, you may wish to override `ForwardingMap.remove(java.lang.Object)` to forward to this implementation.

  Overrides:
    `standardRemove` in class `ForwardingMap<K,V>`
  Since:
    7.0

### standardSubMap

    @Beta
    protected SortedMap<K,V> standardSubMap(K fromKey,
                                                 K toKey)

  A sensible default implementation of `subMap(Object, Object)` in terms of `headMap(Object)` and `tailMap(Object)`. In some situations, you may wish to override `subMap(Object, Object)` to forward to this implementation.

  Since:
    7.0

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2010-2011. All Rights Reserved.